#include <gpinclude\gpdef.h>
#include <gpinclude\gpstdlib.h>
#include <gpinclude\gpstdio.h>
#include <gpinclude\gpgraphic.h>
#include "gpmain.h"
#include <stdio.h>
//TinyGL includes
//#include <GL/glx.h> 
#include <GL/gl.h> 
#include <GL/oscontext.h>

GPDRAWSURFACE gpDraw[2];
int gpPageIndex;
unsigned char FrameBuffer[76800]; //[320][60]; //TinyGL drawing surfaces

#define RGB(r,g,b)    ((r>>5)<<5)|((g>>5)<<2)|((b>>6)<<0)

#define NUM_VERTICES 150
#define NUM_FACES 70

//prototypes
void Delay(int ms);
void PutPixel(int x, int y, int c);
void Clear(void);

void Triangle(void)
{
    glBegin(GL_TRIANGLES);
    glColor3f(1.0,0.0,0.0);
    glVertex2f(-0.3, -0.3);
    glColor3f(0.0,1.0,0.0);
    glVertex2f(0.3, -0.3);
    glColor3f(0.0,0.0,1.0);
    glVertex2i(-30,30);
    glEnd();
}

void reshape( int width, int height )
{
   glViewport(0, 0, (GLint)width, (GLint)height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glFrustum( -1.0, 1.0, -1.0, 1.0, 5.0, 15.0 );
   glMatrixMode(GL_MODELVIEW);
}

int tkSwapBuffers(void)
{
   int i;
   //FrameBuffers[gpPageIndex++];
   GpSurfaceFlip(&gpDraw[gpPageIndex++]); 
   gpPageIndex %= 2;
   i++;
   return 0;
}

void GpMain(void * arg)
{
    int i;
    ostgl_context *Context;

    GpGraphicModeSet(8, NULL);
    
    glShadeModel( GL_FLAT );
    glDisable( GL_DITHER );

    for(i=0;i<2;i++)
    {      
        GpLcdSurfaceGet(&gpDraw[i],i);
        
    } 

    GpSurfaceSet(&gpDraw[0]); 
    gpPageIndex = 1;
    Context=ostgl_create_context(320,
                     240,
                     16,
                     (void*)*FrameBuffer,
                     1);
    ostgl_make_current(Context,1);
    ostgl_resize(Context,
             320,
             240,
             (void *)FrameBuffer);

    
    //glRenderMode(GL_SELECT);
    //glSelectBuffer(76800,(unsigned int*)FrameBuffer);
    //reshape(320,240);
    //glRenderMode(GL_RENDER);
    while(1)
     {
         //GpRectFill(NULL, &gpDraw[gpPageIndex], 0, 0, 320, 240, RGB(0,0,255));

         //Delay(10);
         Clear();
         glClearColor(1,1,0,0);
         glClear( GL_COLOR_BUFFER_BIT );
         Triangle();
         glFlush();
         PutPixel(rand()%320,rand()%240,RGB(255,255,255));
         GpTextOut(NULL, &gpDraw[gpPageIndex], 2, 2,(char*)stderr, RGB(0,0,1)); 
         GpBitBlt(NULL,&gpDraw[gpPageIndex],0,0,320,240,
                  FrameBuffer,0,0,320,240);
         tkSwapBuffers();
     }
}

void Delay(int ms) {

unsigned int ticks;

    ticks=GpTickCountGet();
    while(GpTickCountGet()-ticks<ms);
}

void PutPixel(int x, int y, int c)
{
    // you can optimize this function...
    // i did not add here any pixels range conditions
    // checking...
    // x = 0..319      y = 0..239 
   // unsigned char *p_buf;
    FrameBuffer[((y<<8)+(y<<7))+x] = c;
    //p_buf = (unsigned char *)(FrameBuffer);//gpDraw[gpPageIndex].ptbuffer);
    //*(p_buf + x*240 + (239-y)) = c;
}

void Clear(void)
{
    int size;
    
    size = (320*240)/32;

    __asm
    {
        mov r0, FrameBuffer
        mov r1, size
        mov r2, #0
        mov r3, #0
        mov r4, #0
        mov r5, #0
        mov r6, #0
        mov r7, #0
        mov r8, #0
        mov r9, #0
loop:
        stmia r0!,{r2-r9}
        subs r1,r1,#1
        bne loop
    }
}